#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <StaticConstants.au3>
#include <EditConstants.au3>
#include <Array.au3>
;~ #include <Constants.au3>

#Region Variable Start
Local Const $ImageWuerfel =  @ScriptDir & "\Images\WUERFEL_"
Global $Zahl_Max = 6 ;Maximum fr Random
Global $Anzahl_Wuerfe = 0 ;Zhlt die Wrfe und verhindert das nicht mehr als 3 Wrfe pro Runde gemacht werden
Global $Image_Wuerfel_1 ;GUIC fr Image Wrfel
Global $Image_Wuerfel_2
Global $Image_Wuerfel_3
Global $Image_Wuerfel_4
Global $Image_Wuerfel_5
Local $Wurf_Btn ;Button Wrfeln
Local $LbWurf ;Label fr Wrfe 0 bis 3
Local $Lb_Hold_1 ;Label HALTEN pro Wrfel
Local $Lb_Hold_2
Local $Lb_Hold_3
Local $Lb_Hold_4
Local $Lb_Hold_5
Global $InpEiner
Global $InpZweier
Global $InpDreier
Global $InpVierer
Global $InpFuenfer
Global $InpSechser
Global $InpBonus
Global $InpSummeTeil_1
Global $InpZweiPaar
Global $InpDreierpasch
Global $InpViererpasch
Global $InpFullHouse
Global $InpKleineStrasse
Global $InpGrosseStrasse
Global $InpYatzy
Global $InpChanze
Global $InpSummeTeil_2
Global $InpEndsumme
Local $aInfo ;Erfragt die Position des Mauszeigers relativ zum GUI-Fenster fr Input-Punkte vergabe
Local $hGUI
Global $RND_W1 = 0 ;Random fr GUICtrlCreatePic
Global $RND_W2 = 0
Global $RND_W3 = 0
Global $RND_W4 = 0
Global $RND_W5 = 0
Global $aArray_Wurf ;Jeder Wurf in eine Array schreiben
Global $SperrenPunkte = 1 ;Verhindert mehrauswahl der Punkte
#Region GVariable END

#Region GUI Start
;Hauptfenster erstellen
$hGUI = GUICreate("YATZY",700,650, -1, -1)
;~ GUISetBkColor("0xF5F5DC")


;GUICtrlCreatePic erstellen fr Wrfel
$Image_Wuerfel_1 = GUICtrlCreatePic(@ScriptDir & "\Images\Y.bmp",121,40,74,74,Bitor($SS_SUNKEN,$GUI_DOCKSIZE))
$Image_Wuerfel_2 = GUICtrlCreatePic(@ScriptDir & "\Images\A.bmp",214,40,74,74,Bitor($SS_SUNKEN,$GUI_DOCKSIZE))
$Image_Wuerfel_3 = GUICtrlCreatePic(@ScriptDir & "\Images\T.bmp",307,40,74,74,Bitor($SS_SUNKEN,$GUI_DOCKSIZE))
$Image_Wuerfel_4 = GUICtrlCreatePic(@ScriptDir & "\Images\Z.bmp",400,40,74,74,Bitor($SS_SUNKEN,$GUI_DOCKSIZE))
$Image_Wuerfel_5 = GUICtrlCreatePic(@ScriptDir & "\Images\Y.bmp",493,40,74,74,Bitor($SS_SUNKEN,$GUI_DOCKSIZE))

;Wrfelbilder fr Nummer 1 bis 6 erstellen & GUICtrlSetTip pro Bild
Local $Top = 250
For $t = 1 To 6
   GUICtrlCreatePic(@ScriptDir & "\Images\WUERFEL_" & $t & ".bmp",125,$Top,30,30)
   GUICtrlSetTip(-1, "Alle " & $t & "er", "Info:", 1, 1)
   $Top += 40
Next

;Input fr Punkte 1 bis 6 erstellen
$InpEiner = GUICtrlCreateInput("", 165, 250, 50, 30, BitOR($ES_NUMBER,$ES_CENTER,$ES_READONLY))
GUICtrlSetFont(-1,12,700,0,"MS Sans Serif")
GUICtrlSetBkColor(-1, "0xFCFCFC")

$InpZweier = GUICtrlCreateInput("", 165, 290, 50, 30, BitOR($ES_NUMBER,$ES_CENTER,$ES_READONLY))
GUICtrlSetFont(-1,12,700,0,"MS Sans Serif")
GUICtrlSetBkColor(-1, "0xFCFCFC")

$InpDreier = GUICtrlCreateInput("", 165, 330, 50, 30, BitOR($ES_NUMBER,$ES_CENTER,$ES_READONLY))
GUICtrlSetFont(-1,12,700,0,"MS Sans Serif")
GUICtrlSetBkColor(-1, "0xFCFCFC")

$InpVierer = GUICtrlCreateInput("", 165, 370, 50, 30, BitOR($ES_NUMBER,$ES_CENTER,$ES_READONLY))
GUICtrlSetFont(-1,12,700,0,"MS Sans Serif")
GUICtrlSetBkColor(-1, "0xFCFCFC")

$InpFuenfer = GUICtrlCreateInput("", 165, 410, 50, 30, BitOR($ES_NUMBER,$ES_CENTER,$ES_READONLY))
GUICtrlSetFont(-1,12,700,0,"MS Sans Serif")
GUICtrlSetBkColor(-1, "0xFCFCFC")

$InpSechser = GUICtrlCreateInput("", 165, 450, 50, 30, BitOR($ES_NUMBER,$ES_CENTER,$ES_READONLY))
GUICtrlSetFont(-1,12,700,0,"MS Sans Serif")
GUICtrlSetBkColor(-1, "0xFCFCFC")

;Label Bonus  & Input erstellen
GUICtrlCreateLabel("BONUS", 85, 498, 70, 20, $SS_RIGHT)
GUICtrlSetTip(-1, "Erreicht ein Spieler in den ersten sechs Feldern zusammen 63 oder mehr Punkte," & @CRLF & _
				  "so wird ein Bonus von 35 Punkten gutgeschrieben. ", "Bonus:", 1, 1)
GUICtrlSetFont(-1,10,700,0,"MS Sans Serif")
$InpBonus = GUICtrlCreateInput("0", 165, 490, 50, 30, BitOR($ES_NUMBER,$ES_CENTER,$ES_READONLY))
GUICtrlSetFont(-1,12,700,0,"MS Sans Serif")
GUICtrlSetBkColor(-1, "0xF5F6CE")

;Label SUMME Teil 1  & Input erstellen
GUICtrlCreateLabel("SUMME Teil 1", 55, 536, 100, 20, $SS_RIGHT)
GUICtrlSetFont(-1,10,700,0,"MS Sans Serif")
$InpSummeTeil_1 = GUICtrlCreateInput("0", 165, 530, 50, 30, BitOR($ES_CENTER,$ES_READONLY))
GUICtrlSetFont(-1,12,700,0,"MS Sans Serif")
GUICtrlSetBkColor(-1, "0xCEF6CE")

;Label Endsumme  & Input erstellen
GUICtrlCreateLabel("Endsumme", 55, 576, 100, 20, $SS_RIGHT)
GUICtrlSetTip(-1, "Max. 379 Punkte mglich", "Info:", 1, 1)
GUICtrlSetFont(-1,10,700,0,"MS Sans Serif")
$InpEndsumme = GUICtrlCreateInput("0", 165, 570, 50, 30, BitOR($ES_CENTER,$ES_READONLY))
GUICtrlSetFont(-1,12,700,0,"MS Sans Serif")
GUICtrlSetBkColor(-1, "0xF6CECE")

;Label Zwei Paar  & Input erstellen
GUICtrlCreateLabel("Zwei Paar", 385, 255, 120, 20, $SS_RIGHT)
GUICtrlSetTip(-1, "11 / 22 / 33 usw.", "Varianten:", 1, 1)
GUICtrlSetFont(-1,10,700,0,"MS Sans Serif")
$InpZweiPaar = GUICtrlCreateInput("", 515, 250, 50, 30, BitOR($ES_NUMBER,$ES_CENTER,$ES_READONLY))
GUICtrlSetFont(-1,12,700,0,"MS Sans Serif")
GUICtrlSetBkColor(-1, "0xFCFCFC")

;Label Dreierpasch  & Input erstellen
GUICtrlCreateLabel("Dreierpasch", 385, 295, 120, 20, $SS_RIGHT)
GUICtrlSetTip(-1, "111 / 222 / 333 usw.", "Varianten:", 1, 1)
GUICtrlSetFont(-1,10,700,0,"MS Sans Serif")
$InpDreierpasch = GUICtrlCreateInput("", 515, 290, 50, 30, BitOR($ES_NUMBER,$ES_CENTER,$ES_READONLY))
GUICtrlSetFont(-1,12,700,0,"MS Sans Serif")
GUICtrlSetBkColor(-1, "0xFCFCFC")

;Label Viererpasch  & Input erstellen
GUICtrlCreateLabel("Viererpasch", 385, 335,120, 20, $SS_RIGHT)
GUICtrlSetTip(-1, "1111 / 2222 / 3333 usw.", "Varianten:", 1, 1)
GUICtrlSetFont(-1,10,700,0,"MS Sans Serif")
$InpViererpasch = GUICtrlCreateInput("", 515, 330, 50, 30, BitOR($ES_NUMBER,$ES_CENTER,$ES_READONLY))
GUICtrlSetFont(-1,12,700,0,"MS Sans Serif")
GUICtrlSetBkColor(-1, "0xFCFCFC")

;Label Full House  & Input erstellen
GUICtrlCreateLabel("Full House", 385, 375,120, 20, $SS_RIGHT)
GUICtrlSetTip(-1, "11333 / 11122" & @CRLF & "33366 / 22255  usw." & @CRLF & @CRLF & " 30 Punkte", "Varianten:", 1, 1)
GUICtrlSetFont(-1,10,700,0,"MS Sans Serif")
$InpFullHouse = GUICtrlCreateInput("", 515, 370, 50, 30, BitOR($ES_NUMBER,$ES_CENTER,$ES_READONLY))
GUICtrlSetFont(-1,12,700,0,"MS Sans Serif")
GUICtrlSetBkColor(-1, "0xFCFCFC")

;Label Kleine Strasse  & Input erstellen
GUICtrlCreateLabel("Kleine Strasse", 385, 415,120, 20, $SS_RIGHT)
GUICtrlSetTip(-1, "1234 / 2345 / 3456" & @CRLF & @CRLF & " 35 Punkte", "Varianten:", 1, 1)
GUICtrlSetFont(-1,10,700,0,"MS Sans Serif")
$InpKleineStrasse = GUICtrlCreateInput("", 515, 410, 50, 30, BitOR($ES_NUMBER,$ES_CENTER,$ES_READONLY))
GUICtrlSetFont(-1,12,700,0,"MS Sans Serif")
GUICtrlSetBkColor(-1, "0xFCFCFC")

;Label Grosse Strasse  & Input erstellen
GUICtrlCreateLabel("Grosse Strasse", 385, 455,120, 20, $SS_RIGHT)
GUICtrlSetTip(-1, "12345 / 23456" & @CRLF & @CRLF & " 45 Punkte", "Varianten:", 1, 1)
GUICtrlSetFont(-1,10,700,0,"MS Sans Serif")
$InpGrosseStrasse = GUICtrlCreateInput("", 515, 450, 50, 30, BitOR($ES_NUMBER,$ES_CENTER,$ES_READONLY))
GUICtrlSetFont(-1,12,700,0,"MS Sans Serif")
GUICtrlSetBkColor(-1, "0xFCFCFC")

;Label Yatzy  & Input erstellen
GUICtrlCreateLabel("Yatzy", 385, 495,120, 20, $SS_RIGHT)
GUICtrlSetTip(-1, "11111 / 22222 / 33333 usw." & @CRLF & @CRLF & " 75 Punkte", "Varianten:", 1, 1)
GUICtrlSetFont(-1,10,700,0,"MS Sans Serif")
$InpYatzy = GUICtrlCreateInput("", 515, 490, 50, 30, BitOR($ES_NUMBER,$ES_CENTER,$ES_READONLY))
GUICtrlSetFont(-1,12,700,0,"MS Sans Serif")
GUICtrlSetBkColor(-1, "0xFCFCFC")

;Label Chanze  & Input erstellen
GUICtrlCreateLabel("CHANZE", 385, 535, 120, 20, $SS_RIGHT)
GUICtrlSetTip(-1, "Jeder Wrfel zhlt", "Varianten:", 1, 1)
GUICtrlSetFont(-1,10,700,0,"MS Sans Serif")
$InpChanze = GUICtrlCreateInput("", 515, 530, 50, 30, BitOR($ES_NUMBER,$ES_CENTER,$ES_READONLY))
GUICtrlSetFont(-1,12,700,0,"MS Sans Serif")
GUICtrlSetBkColor(-1, "0xFCFCFC")

;Label SUMME Teil 2  & Input erstellen
GUICtrlCreateLabel("SUMME Teil 2", 385, 575, 120, 20, $SS_RIGHT)
GUICtrlSetFont(-1,10,700,0,"MS Sans Serif")
$InpSummeTeil_2 = GUICtrlCreateInput("0", 515, 570, 50, 30, BitOR($ES_CENTER,$ES_READONLY))
GUICtrlSetFont(-1,12,700,0,"MS Sans Serif")
GUICtrlSetBkColor(-1, "0xCEF6CE")

;Label HOLD unterhalb der Wrfel erstellen
$Lb_Hold_1 = GUICtrlCreateLabel("HALTEN", 123, 120, 70, 20, $SS_CENTER)
GUICtrlSetFont(-1,10,700,0,"MS Sans Serif")
GUICtrlSetColor(-1, "0xFF0000")
GUICtrlSetState(-1, $GUI_HIDE)

$Lb_Hold_2 = GUICtrlCreateLabel("HALTEN", 216, 120, 70, 20, $SS_CENTER)
GUICtrlSetFont(-1,10,700,0,"MS Sans Serif")
GUICtrlSetColor(-1, "0xFF0000")
GUICtrlSetState(-1, $GUI_HIDE)

$Lb_Hold_3 = GUICtrlCreateLabel("HALTEN", 309, 120, 70, 20, $SS_CENTER)
GUICtrlSetFont(-1,10,700,0,"MS Sans Serif")
GUICtrlSetColor(-1, "0xFF0000")
GUICtrlSetState(-1, $GUI_HIDE)

$Lb_Hold_4 = GUICtrlCreateLabel("HALTEN", 402, 120, 70, 20, $SS_CENTER)
GUICtrlSetFont(-1,10,700,0,"MS Sans Serif")
GUICtrlSetColor(-1, "0xFF0000")
GUICtrlSetState(-1, $GUI_HIDE)

$Lb_Hold_5 = GUICtrlCreateLabel("HALTEN", 495, 120, 70, 20, $SS_CENTER)
GUICtrlSetFont(-1,10,700,0,"MS Sans Serif")
GUICtrlSetColor(-1, "0xFF0000")
GUICtrlSetState(-1, $GUI_HIDE)

;Label Anzahl Wuerfe erstellen
$LbWurf = GUICtrlCreateLabel("0 von 3 Wrfen", 268, 5, 150, 25, $SS_CENTER)
GUICtrlSetFont(-1,14,700,0,"MS Sans Serif")
GUICtrlSetColor(-1, "0x009900")

;Button zum Wrfeln erstellen
$Wurf_Btn = GUICtrlCreateButton("Wrfeln",121,150,448,70)
GUICtrlSetFont(-1,30,700,0,"Comic Sans Ms")

#EndRegion GUI End


GUISetState(@SW_SHOW)

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
	  Case $GUI_EVENT_CLOSE
		 Exit

	  Case $Wurf_Btn ;Click Wrfel Button
		 If GUICtrlRead($Wurf_Btn) = "Neues Spiel" Then ;Text auf Button auslesen
			_NeuesSpielStarten()
			_BtWuerfeln() ;Automatisch Wrfeln
		 Else
			_BtWuerfeln()
		 EndIf

	  Case $Image_Wuerfel_1 ;Click Wrfel Image fr HOLD
		 If GUICtrlGetState($Lb_Hold_1) = 80 Then ;Prfen ob Halten sichbar ist, wenn Ja Halten ausblenden oder einblenden
			GUICtrlSetState($Lb_Hold_1, $GUI_HIDE)
		 Else
			GUICtrlSetState($Lb_Hold_1, $GUI_SHOW)
		 EndIf

	  Case $Image_Wuerfel_2 ;Click Wrfel Image
		 If GUICtrlGetState($Lb_Hold_2) = 80 Then
			GUICtrlSetState($Lb_Hold_2, $GUI_HIDE)
		 Else
			GUICtrlSetState($Lb_Hold_2, $GUI_SHOW)
		 EndIf

	  Case $Image_Wuerfel_3 ;Click Wrfel Image
		 If GUICtrlGetState($Lb_Hold_3) = 80 Then
			GUICtrlSetState($Lb_Hold_3, $GUI_HIDE)
		 Else
			GUICtrlSetState($Lb_Hold_3, $GUI_SHOW)
		 EndIf

	  Case $Image_Wuerfel_4 ;Click Wrfel Image
		 If GUICtrlGetState($Lb_Hold_4) = 80 Then
			GUICtrlSetState($Lb_Hold_4, $GUI_HIDE)
		 Else
			GUICtrlSetState($Lb_Hold_4, $GUI_SHOW)
		 EndIf

	  Case $Image_Wuerfel_5 ;Click Wrfel Image
		 If GUICtrlGetState($Lb_Hold_5) = 80 Then
			GUICtrlSetState($Lb_Hold_5, $GUI_HIDE)
		 Else
			GUICtrlSetState($Lb_Hold_5, $GUI_SHOW)
		 EndIf

    EndSwitch

  ;Input Klick abfrage fr Input
  $aInfo = GUIGetCursorInfo($hGUI)
  If $aInfo[2] Then
;~ 	  GuiCtrlSetState($Wurf_Btn,$GUI_FOCUS)
	  If $SperrenPunkte = 1 Then ContinueLoop ;Verhindert mehrfach auswahl
	  Select
		 Case $aInfo[4] = $InpEiner
			If GUICtrlRead($InpEiner) >= "0" Then ContinueLoop
			$SumWurf = _ArrayFindAll($aArray_Wurf, 1)
			If UBound($SumWurf) > 0 Then
			   GUICtrlSetData($InpEiner, UBound($SumWurf) * 1)
			Else
			   GUICtrlSetData($InpEiner, 0)
			EndIf
			_PunkteBerechnen()

		 Case $aInfo[4] = $InpZweier
			If GUICtrlRead($InpZweier) >= "0" Then ContinueLoop
			$SumWurf = _ArrayFindAll($aArray_Wurf, 2)
			If UBound($SumWurf) > 0 Then
			   GUICtrlSetData($InpZweier, UBound($SumWurf) * 2)
			Else
			   GUICtrlSetData($InpZweier, 0)
			EndIf
			_PunkteBerechnen()

		 Case $aInfo[4] = $InpDreier
			$SumWurf = _ArrayFindAll($aArray_Wurf, 3)
			If UBound($SumWurf) > 0 Then
			   GUICtrlSetData($InpDreier, UBound($SumWurf) * 3)
			Else
			   GUICtrlSetData($InpDreier, 0)
			EndIf
			_PunkteBerechnen()

		 Case $aInfo[4] = $InpVierer
			If GUICtrlRead($InpVierer) >= "0" Then ContinueLoop
			$SumWurf = _ArrayFindAll($aArray_Wurf, 4)
			If UBound($SumWurf) > 0 Then
			   GUICtrlSetData($InpVierer, UBound($SumWurf) * 4)
			Else
			   GUICtrlSetData($InpVierer, 0)
			EndIf
			_PunkteBerechnen()

		 Case $aInfo[4] = $InpFuenfer
			If GUICtrlRead($InpFuenfer) >= "0" Then ContinueLoop
			$SumWurf = _ArrayFindAll($aArray_Wurf, 5)
			If UBound($SumWurf) > 0 Then
			   GUICtrlSetData($InpFuenfer, UBound($SumWurf) * 5)
			Else
			   GUICtrlSetData($InpFuenfer, 0)
			EndIf
			_PunkteBerechnen()

		 Case $aInfo[4] = $InpSechser
			If GUICtrlRead($InpSechser) >= "0" Then ContinueLoop
			$SumWurf = _ArrayFindAll($aArray_Wurf, 6)
			If UBound($SumWurf) > 0 Then
			   GUICtrlSetData($InpSechser, UBound($SumWurf) * 6)
			Else
			   GUICtrlSetData($InpSechser, 0)
			EndIf
			_PunkteBerechnen()

		 Case $aInfo[4] = $InpZweiPaar
			If GUICtrlRead($InpZweiPaar) >= "0" Then ContinueLoop
			For $z = 6 To 1 Step -1
			   $FindInArray = _ArrayFindAll($aArray_Wurf, $z)
			   If UBound($FindInArray) >= 2 Then
				  GUICtrlSetData($InpZweiPaar, 2 * $z)
				  $z = 0
			   ElseIf UBound($FindInArray) = 0 Then
				  GUICtrlSetData($InpZweiPaar, 0)
			   EndIf
			Next
			_PunkteBerechnen()

		 Case $aInfo[4] = $InpDreierpasch
			If GUICtrlRead($InpDreierpasch) >= "0" Then ContinueLoop
			For $z = 6 To 1 Step -1
			   $FindInArray = _ArrayFindAll($aArray_Wurf, $z)
			   If UBound($FindInArray) >= 3 Then
				  GUICtrlSetData($InpDreierpasch, 3 * $z)
				  $z = 0
			   ElseIf UBound($FindInArray) = 0 Then
				  GUICtrlSetData($InpDreierpasch, 0)
			   EndIf
			Next
			_PunkteBerechnen()

		 Case $aInfo[4] = $InpViererpasch
			If GUICtrlRead($InpViererpasch) >= "0" Then ContinueLoop
			For $z = 6 To 1 Step -1
			   $FindInArray = _ArrayFindAll($aArray_Wurf, $z)
			   If UBound($FindInArray) >= 4 Then
				  GUICtrlSetData($InpViererpasch, 4 * $z)
				  $z = 0
			   ElseIf UBound($FindInArray) = 0 Then
				  GUICtrlSetData($InpViererpasch, 0)
			   EndIf
			Next
			_PunkteBerechnen()

		 Case $aInfo[4] = $InpFullHouse
			If GUICtrlRead($InpFullHouse) >= "0" Then ContinueLoop
			$FindInArray = _ArrayPermute($aArray_Wurf)
			For $z = 1 To UBound($FindInArray) -1
			   $RegExp = StringRegExp($FindInArray[$z], "(11222|11333|11444|11555|11666|11122|11133|11144|11155|11166|" & _
														 "22111|22333|22444|22555|22666|22211|22233|22244|22255|22266|" & _
														 "33111|33222|33444|33555|33666|33311|33322|33344|33355|33366|" & _
														 "44111|44222|44333|44555|44666|44411|44422|44433|44455|44466|" & _
														 "55111|55222|55333|55444|55666|55511|55522|55533|55544|55566|" & _
														 "66111|66222|66333|66444|66555|66611|66622|66633|66644|66655)")
			   If $RegExp = 1 Then
				  GUICtrlSetData($InpFullHouse, 30)
				  ExitLoop
			   ElseIf $z = UBound($FindInArray) -1 Then
				  GUICtrlSetData($InpFullHouse, 0)
			   EndIf
			Next
			_PunkteBerechnen()

		 Case $aInfo[4] = $InpKleineStrasse
			If GUICtrlRead($InpKleineStrasse) >= "0" Then ContinueLoop
			$FindInArray = _ArrayPermute($aArray_Wurf)
			For $z = 1 To UBound($FindInArray) -1
			   $RegExp = StringRegExp($FindInArray[$z], "(1234|2345|3456)")
			   If $RegExp = 1 Then
				  GUICtrlSetData($InpKleineStrasse, 35)
				  ExitLoop
			   ElseIf $z = UBound($FindInArray) -1 Then
				  GUICtrlSetData($InpKleineStrasse, 0)
			   EndIf
			Next
			_PunkteBerechnen()

		 Case $aInfo[4] = $InpGrosseStrasse
			If GUICtrlRead($InpGrosseStrasse) >= "0" Then ContinueLoop
			$FindInArray = _ArrayPermute($aArray_Wurf)
			For $z = 1 To UBound($FindInArray) -1
			   $RegExp = StringRegExp($FindInArray[$z], "(12345|23456)")
			   If $RegExp = 1 Then
				  GUICtrlSetData($InpGrosseStrasse, 45)
				  ExitLoop
			   ElseIf $z = UBound($FindInArray) -1 Then
				  GUICtrlSetData($InpGrosseStrasse, 0)
			   EndIf
			Next
			_PunkteBerechnen()

		 Case $aInfo[4] = $InpYatzy
			If GUICtrlRead($InpYatzy) >= "0" Then ContinueLoop
			$FindInArray = _ArrayPermute($aArray_Wurf)
			For $z = 1 To UBound($FindInArray) -1
			   $RegExp = StringRegExp($FindInArray[$z], "(11111|22222|33333|44444|55555|66666)")
			   If $RegExp = 1 Then
				  GUICtrlSetData($InpYatzy, 75)
				  ExitLoop
			   ElseIf $z = UBound($FindInArray) -1 Then
				  GUICtrlSetData($InpYatzy, 0)
			   EndIf
			Next
			_PunkteBerechnen()

		 Case $aInfo[4] = $InpChanze
			If GUICtrlRead($InpChanze) >= "0" Then ContinueLoop
			   GUICtrlSetData($InpChanze, $RND_W1 + $RND_W2 + $RND_W3 + $RND_W4 + $RND_W5)
			_PunkteBerechnen()

	  EndSelect
  EndIf

 WEnd

Func _BtWuerfeln()
   $Anzahl_Wuerfe += 1
   $SperrenPunkte = 0
   GUICtrlSetData($LbWurf, $Anzahl_Wuerfe & " von 3 Wrfen")
   If $Anzahl_Wuerfe = 3 Then GUICtrlSetState($Wurf_Btn, $GUI_DISABLE)
   For $xb = 1 To 3

	  If GUICtrlGetState($Lb_Hold_1) = 80 Then
	  Else
		 $RND_W1 = Random(1, $Zahl_Max, 1)
		 GUICtrlSetImage($Image_Wuerfel_1, $ImageWuerfel & $RND_W1 & ".jpg") ;Wrfel Bild laden
	  EndIf

	  If GUICtrlGetState($Lb_Hold_2) = 80 Then
	  Else
		 $RND_W2 = Random(1, $Zahl_Max, 1)
		 GUICtrlSetImage($Image_Wuerfel_2, $ImageWuerfel & $RND_W2 & ".jpg") ;Wrfel Bild laden
	  EndIf

	  If GUICtrlGetState($Lb_Hold_3) = 80 Then
	  Else
		  $RND_W3 = Random(1, $Zahl_Max, 1)
		 GUICtrlSetImage($Image_Wuerfel_3, $ImageWuerfel & $RND_W3 & ".jpg") ;Wrfel Bild laden
	  EndIf

	  If GUICtrlGetState($Lb_Hold_4) = 80 Then
	  Else
		 $RND_W4 = Random(1, $Zahl_Max, 1)
		 GUICtrlSetImage($Image_Wuerfel_4, $ImageWuerfel & $RND_W4 & ".jpg") ;Wrfel Bild laden
	  EndIf

	  If GUICtrlGetState($Lb_Hold_5) = 80 Then
	  Else
		 $RND_W5 = Random(1, $Zahl_Max, 1)
		 GUICtrlSetImage($Image_Wuerfel_5, $ImageWuerfel & $RND_W5 & ".jpg") ;Wrfel Bild laden
	  EndIf
	  Sleep(20)
   Next

	  Global $aArray_Wurf[5] = [$RND_W1, $RND_W2, $RND_W3, $RND_W4, $RND_W5]

EndFunc

Func _PunkteBerechnen()
   $Anzahl_Wuerfe = 0
   $SperrenPunkte = 1
   GUICtrlSetData($LbWurf, "0 von 3 Wrfen")
   GUICtrlSetState($Wurf_Btn, $GUI_ENABLE)
   GUICtrlSetState($Lb_Hold_1, $GUI_HIDE)
   GUICtrlSetState($Lb_Hold_2, $GUI_HIDE)
   GUICtrlSetState($Lb_Hold_3, $GUI_HIDE)
   GUICtrlSetState($Lb_Hold_4, $GUI_HIDE)
   GUICtrlSetState($Lb_Hold_5, $GUI_HIDE)

   ;Summe von Teil_1 berechnen
   GUICtrlSetData($InpSummeTeil_1, GUICtrlRead($InpEiner) + GUICtrlRead($InpZweier) + GUICtrlRead($InpDreier) + GUICtrlRead($InpVierer) _
   + GUICtrlRead($InpFuenfer) +  GUICtrlRead($InpSechser))

   ;Bonus prfen
   If GUICtrlRead($InpSummeTeil_1) >= 63 Then
	  GUICtrlSetData($InpBonus, "35")
	  GUICtrlSetData($InpSummeTeil_1, GUICtrlRead($InpSummeTeil_1) + GUICtrlRead($InpBonus))
   EndIf

   ;;Summe von Teil_2 berechnen
   GUICtrlSetData($InpSummeTeil_2, GUICtrlRead($InpZweiPaar) + GUICtrlRead($InpDreierpasch) + GUICtrlRead($InpViererpasch) + GUICtrlRead($InpFullHouse) _
   + GUICtrlRead($InpKleineStrasse)  + GUICtrlRead($InpGrosseStrasse) + GUICtrlRead($InpYatzy) + GUICtrlRead($InpChanze))

   ;Gesamt Summe von Teil_1 & Teil_2
   GUICtrlSetData($InpEndsumme, GUICtrlRead($InpSummeTeil_1) + GUICtrlRead($InpSummeTeil_2))

   ;Prfen ob alle InputBoxen ausgefllt sind
   If  GUICtrlRead($InpEiner) >= "0" And  GUICtrlRead($InpZweier) >= "0" And GUICtrlRead($InpDreier) >= "0" And GUICtrlRead($InpVierer) >= "0" _
	  And GUICtrlRead($InpFuenfer) >= "0" And GUICtrlRead($InpSechser) >= "0" And GUICtrlRead($InpZweiPaar) >= "0" And GUICtrlRead($InpDreierpasch) >= "0" _
	  And GUICtrlRead($InpViererpasch) >= "0" And GUICtrlRead($InpFullHouse) >= "0" And GUICtrlRead($InpKleineStrasse) >= "0" _
	  And GUICtrlRead($InpGrosseStrasse) >= "0" And GUICtrlRead($InpYatzy) >= "0" And GUICtrlRead($InpChanze) >= "0" Then

		 GUICtrlSetData($Wurf_Btn, "Neues Spiel")
   EndIf

   GuiCtrlSetState($Wurf_Btn,$GUI_FOCUS)
EndFunc

Func _NeuesSpielStarten()
   GUICtrlSetData($Wurf_Btn, "Wrfeln")
   GUICtrlSetData($InpEiner, "")
   GUICtrlSetData($InpZweier, "")
   GUICtrlSetData($InpDreier, "")
   GUICtrlSetData($InpVierer, "")
   GUICtrlSetData($InpFuenfer, "")
   GUICtrlSetData($InpSechser, "")
   GUICtrlSetData($InpZweiPaar, "")
   GUICtrlSetData($InpDreierpasch, "")
   GUICtrlSetData($InpViererpasch, "")
   GUICtrlSetData($InpFullHouse, "")
   GUICtrlSetData($InpKleineStrasse, "")
   GUICtrlSetData($InpGrosseStrasse, "")
   GUICtrlSetData($InpYatzy, "")
   GUICtrlSetData($InpChanze, "")
   GUICtrlSetData($InpBonus, "")
   GUICtrlSetData($InpSummeTeil_1, "")
   GUICtrlSetData($InpSummeTeil_2, "")
   GUICtrlSetData($InpEndsumme, "")
EndFunc
